From: Sophie Brun <sophie@offensive-security.com>
Date: Fri, 17 Nov 2023 12:23:25 +0100
Subject: Move API keys to a config file

Upstream asks the user to modify the keys directly in *.py files.
- add a config file which the user can modify
- adapt the code to use the config file
- update upstream README
---
 README.md              |  6 ++----
 core/config.py         |  8 ++++++++
 plugins/Phonenumber.py |  2 +-
 plugins/api.py         | 11 ++++++++---
 plugins/ipaddress.py   |  4 ++--
 plugins/proxy.py       |  2 +-
 reconspider.py         |  5 +++++
 7 files changed, 27 insertions(+), 11 deletions(-)
 create mode 100644 core/config.py

diff --git a/README.md b/README.md
index 443db9f..6f4ccd3 100644
--- a/README.md
+++ b/README.md
@@ -113,11 +113,9 @@ https://lite.ip2location.com/database/px8-ip-proxytype-country-region-city-isp-d
 Download database, extract it and move to `reconspider/plugins/` directory.
 
 
-# Updating API Keys
+# API Keys
 
-APIs included in ReconSpider are FREE and having limited & restricted usage per month, Please update the current APIs with New APIs in `setup.py` file, and re-install once done to reflect the changes.
-
-> Warning: Not updating the APIs can result in not showing the expected output or it may show errors.
+Please add the current APIs with New APIs in /etc/reconspider/reconspider.conf
 
 You need to create the account and get the API Keys from the following websites.
 
diff --git a/core/config.py b/core/config.py
new file mode 100644
index 0000000..0c065c0
--- /dev/null
+++ b/core/config.py
@@ -0,0 +1,8 @@
+import configparser
+
+config=configparser.ConfigParser()
+config.read('/etc/reconspider/reconspider.conf')
+
+def shodan_api():
+    api = config['core']['shodanAPI']
+    return str(api)
diff --git a/plugins/Phonenumber.py b/plugins/Phonenumber.py
index 8889f21..0fd963b 100644
--- a/plugins/Phonenumber.py
+++ b/plugins/Phonenumber.py
@@ -5,7 +5,7 @@ def Phonenumber(ph):
 		print ('[+]' + ' Fetching Phonenumber Details...' + '\n')
 		apikey=phoneapis()
 		if apikey == "":
-				print("Add NumVerify api key to plugins/api.py")
+				print("Add NumVerify api key to /etc/reconspider/reconspider.conf")
 				exit()
 		ph=''.join([i for i in ph if i.isdigit()])
 		for api_key in apikey.split(","):
diff --git a/plugins/api.py b/plugins/api.py
index dcd80fd..89cbe45 100644
--- a/plugins/api.py
+++ b/plugins/api.py
@@ -1,9 +1,14 @@
+import configparser
+
+config=configparser.ConfigParser()
+config.read('/etc/reconspider/reconspider.conf')
+
 def phoneapis():
-    api= "e01791e4d18fbbdfa0c9033bf207decd,2f8c8e865a0b25bbf4da08c4db039b8d"
+    api = config['plugins']['phoneapis']
     return str(api)
 def ipstack():
-    api="276cfee2c31729505691e515e8321a02"
+    api = config['plugins']['IPStackAPI']
     return str(api)
 def gmap():
-    api="AIzaSyAKGik6Fok3_mbIsgquaAnDGNy-h_AjhVw"
+    api = config['plugins']['gmap']
     return str(api)
diff --git a/plugins/ipaddress.py b/plugins/ipaddress.py
index d0774ae..927eb42 100644
--- a/plugins/ipaddress.py
+++ b/plugins/ipaddress.py
@@ -9,10 +9,10 @@ from plugins.webosint.who.whois import *
 
 api_key = ipstack()
 if api_key == "" :
-    print("Add you ipstack api key to plugins/api.py")
+    print("Add your ipstack api key to /etc/reconspider/reconspider.conf")
     exit()
 if gmap() == "" :
-    print("Add you Google Heatmap api key to plugins/api.py")
+    print("Add your Google Heatmap api key to /etc/reconspider/reconspider.conf")
     exit()
 
 def IPHeatmap():
diff --git a/plugins/proxy.py b/plugins/proxy.py
index bf4f269..8988fb7 100644
--- a/plugins/proxy.py
+++ b/plugins/proxy.py
@@ -27,7 +27,7 @@ def ip2Proxy(IP):
             print("Name:" + record['as_name'])
             api_key = ipstack()
             if api_key == "":
-                print("Add you ipstack api key to plugins/api.py")
+                print("Add your ipstack api key to /etc/reconspider/reconspider.conf")
                 exit()
             r = requests.get("http://api.IPstack.com/" + IP + "?access_key=" + api_key)
             response = r.json()
diff --git a/reconspider.py b/reconspider.py
index 91b64e4..669b8e9 100644
--- a/reconspider.py
+++ b/reconspider.py
@@ -31,9 +31,14 @@ ENTER 0 - 13 TO SELECT OPTIONS
        """)
 
 if __name__ == '__main__':
+    import configparser
+    config=configparser.ConfigParser()
+    config.read('/etc/reconspider/reconspider.conf')
     if sys.version_info[0] > 2:
            try:
                   print(banner())
+                  if config['core']['shodanAPI'] == '':
+                        print('\nSeems like you haven\'t add your shodan API key in /etc/reconspider/reconspider.conf, Please add the missing API keys')
                   from core import repl_prompt
            except ModuleNotFoundError:
                   print('\nSeems like you haven\'t installed Requirements or You are not using python3 version, Please install using: python3 setup.py install')
